/*
  $Id$

	Copyright (C) 2015 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

  BASE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3
  of the License, or (at your option) any later version.

  BASE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

import java.util.Date;

/**
	This class holds information about a kit.
	
	@author Nicklas
	@since 3.7
	@see net.sf.basedb.core.Kit
	@hibernate.class table="`Kits`" lazy="true"
*/
public class KitData
	extends AnnotatedData
	implements RegisteredData, SubtypableData
{
	public KitData()
	{}
	/*
		From the RegisteredData interface
		-------------------------------------------
	*/
	private Date entryDate;
	@Override
	public Date getEntryDate()
	{
		return entryDate;
	}
	public void setEntryDate(Date entryDate)
	{
		this.entryDate = entryDate;
	}
	// -------------------------------------------
	
	/*
		From the SubtypableData interface
		----------------------------------
	*/
	private ItemSubtypeData subtype;
	@Override
	public ItemSubtypeData getItemSubtype()
	{
	   return subtype;
	}
	@Override
	public void setItemSubtype(ItemSubtypeData subtype)
	{
	   this.subtype = subtype;
	}
	// ------------------------------
	
	private boolean inactive;
	/**
		A flag indicating if this kit is no longer active.
		@hibernate.property column="`inactive`" type="boolean" not-null="true"
	*/
	public boolean isInactive()
	{
		return inactive;
	}
	public void setInactive(boolean inactive)
	{
		this.inactive = inactive;
	}
	
	private Date expirationDate;
	/**
		Get expiration date for the kit.
		@hibernate.property column="`expiration_date`" type="date" not-null="false"
	*/
	public Date getExpirationDate()
	{
		return expirationDate;
	}
	public void setExpirationDate(Date expirationDate)
	{
		this.expirationDate = expirationDate;
	}

}
