<%-- $Id: index.jsp 6926 2015-06-03 11:05:11Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.AnnotatedItem"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.SimpleProgressReporter"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.util.annotations.RunnableInheritAnnotationsManager"
	import="net.sf.basedb.util.annotations.InheritAnnotationsManager"
	import="net.sf.basedb.util.annotations.InheritSpecification"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Set"
	import="java.util.List"
	import="java.util.ArrayList"
	
	
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final String root = request.getContextPath()+"/";
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final int itemId = Values.getInt(request.getParameter("item_id"));

DbControl newDc = null;
DbControl oldDc = null;
String forward = null;
String message = null;
String redirect = null;
try
{
	if ("EditItem".equals(cmd))
	{
		newDc = sc.newDbControl();
		Annotation a = Annotation.getById(newDc, itemId);
		AnnotationType at = a.getAnnotationType();
		Annotatable item = a.getAnnotationSet().getItem();
		
		redirect = "annotate.jsp?ID=" + ID + "&item_id=" + item.getId() + 
				"&item_type=" + item.getType().name() + 
				"&annotationtype_id=" + at.getId() + "&standalone=1";
		newDc.close();
	}
	else if ("SaveAnnotations".equals(cmd))
	{
		final Item itemType = Item.valueOf(request.getParameter("item_type"));
		newDc = sc.newDbControl();
		oldDc = sc.newDbControl();
		ItemContext cc = sc.getCurrentContext(itemType);
		Annotatable oldItem = (Annotatable)cc.getObject("item");
		Annotatable newItem = (Annotatable)itemType.getById(newDc, itemId);
		oldDc.reattachItem((BasicItem)oldItem, false);
		Base.updateAnnotations(newDc, oldItem, newItem, request);
		oldDc.close();
		newDc.commit();
		cc.removeObject("item");
		message = "Annotations saved";
	}
	else if ("BatchInherit".equals(cmd))
	{
		final Item itemType = Item.valueOf(request.getParameter("item_type"));
		final String subContext = Values.getString(request.getParameter("subcontext"), "");
		final ItemContext cc = sc.getCurrentContext(itemType, subContext);
		
		newDc = sc.newDbControl();

		Set<AnnotatedItem> items = (Set<AnnotatedItem>)cc.getObject("AnnotatedItems");
		cc.removeObject("AnnotatedItems");
		
		RunnableInheritAnnotationsManager manager = new RunnableInheritAnnotationsManager(sc);
		manager.addAllItems(items);
		
		for (Integer atId : Values.getInt(request.getParameter("annotationTypes").split(",")))
		{
			AnnotationType at = AnnotationType.getById(newDc, atId);
			if (at.getDisableInheritance()) continue; // Inheritance has been disabled
			
			InheritSpecification spec = new InheritSpecification(at);
			String action = request.getParameter("action_"+atId);
			
			if ("remove".equals(action))
			{
				spec.setRemove(true);
			}
			else if ("resync".equals(action))
			{
				spec.setResyncCloned(true);
			}
			else
			{
				spec.setClone("clone".equals(action));
				int subtypeId = Values.getInt(request.getParameter("from_"+atId));
				boolean noDup = Values.getBoolean(request.getParameter("nodup_"+atId));
				boolean replaceExisting = Values.getBoolean(request.getParameter("replace_"+atId));
				if (subtypeId != 0)
				{
					spec.setItemSubtype(ItemSubtype.getById(newDc, subtypeId));
				}
				spec.setNoDuplicates(noDup);
				spec.setReplaceExisting(replaceExisting);
			}
			manager.addSpecification(spec);
		}
		newDc.commit();
		
		SimpleProgressReporter progress = new SimpleProgressReporter(null);
		sc.setSessionSetting("progress.inherit-annotations", progress);
		manager.setProgressReporter(progress);
		new Thread(manager).start();
		
		redirect = "../../common/progress_reporter.jsp?ID="+ID+
			"&progress=inherit-annotations&title=Inheriting annotations to " + items.size() + " items";

	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (oldDc != null) oldDc.close();
	if (newDc != null) newDc.close();
}

if (forward != null)
{
	sc.setSessionSetting("alert-message", message);
	pageContext.forward(forward);
}
else if (redirect != null)
{
	sc.setSessionSetting("alert-message", message);
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

